<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | File Management Plugin v1.0 for Geeklog - The Ultimate Weblog             |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API method and 2) implements all the common code needed by the            |
// | File Management plug-in.                                                  |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2000,2001 by the following authors:                         |
// |                                                                           |
// | Authors: Blaine Lang       - langmail@sympatico.ca                        |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id: functions.inc,v 1.5 2002/04/23 04:22:02 blang Exp $

$langfile = $_CONF['path'] . 'plugins/filemgmt/language/' . $_CONF['language'] . '.php';
if (file_exists ($langfile)) 
{
    include_once ($langfile);
}
else 
{
    include_once ($_CONF['path'] . 'plugins/forum/language/english.php');
}

include($_CONF['path'] . 'plugins/filemgmt/config.php');
include_once($_CONF['path'] . 'plugins/filemgmt/install.cfg');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
*/
function plugin_getmenuitems_filemgmt()
{
	global $_CONF, $LANG_FILEMGMT;
    $menuitems = array();
    $menuitems["{$LANG_FILEMGMT['downloads']}"] = $_CONF['site_url'] . "/filemgmt/index.php";
	return $menuitems;
}

/**
* Geeklog is checking to see if this plugin supports comments, tell it yes!
* NOTE: to support comments you must used the same date/time based ID for your
* widget.  In otherwords, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
*/
function plugin_commentsupport_filemgmt() 
{
    // Filemgmt Module will use comments
	$pid=8;
	return true;
}

/**
* shows the statistics for the Filemgmot plugin on stats.php.  If $showsitestats
* is 1 then we are to only print the overall stats in the 'site statistics box'
* otherwise we show the detailed stats for the photo album
*
* @showsitestate        int         Flag to let us know which stats to get
*/
function plugin_showstats_filemgmt($showsitestats) 
{
global $LANG_FILEMGMT, $_FM_TABLES, $_CONF;

    $stat_templates = new Template($_CONF['path_layout'] . 'stats');
    $stat_templates->set_file(array('itemstats'=>'itemstatistics.thtml',
                            'statrow'=>'singlestat.thtml'));
    if ($showsitestats == 1) {
        $total_pages=DB_count($_FM_TABLES['filemgmt_filedetail']);
		$total_downloads=DB_getItem($_FM_TABLES['filemgmt_filedetail'], 'SUM(hits)',"");
        $retval = "<table border = '0' width='100%' cellspacing='0' cellpadding='0'>";
        $retval .= "<tr><td>" . $LANG_FILEMGMT['nofiles'] . "</td>";
        $retval .= "<td align='right'>" . $total_pages . " (" .$total_downloads .")&nbsp;&nbsp;&nbsp;</td></tr></table>";
	} else {
        $result = DB_query("SELECT lid, title, hits from {$_FM_TABLES['filemgmt_filedetail']} WHERE hits > 0 ORDER BY hits desc LIMIT 10");
        $nrows  = DB_numRows($result);
        $retval .= COM_startBlock($LANG_FILEMGMT['StatsMsg1']);
        if ($nrows > 0) {
            $stat_templates->set_var('item_label',"Page Title");
            $stat_templates->set_var('stat_name',"Hits");
            for ($i = 0; $i < $nrows && $i < 10; $i++) {
				list ($lid, $title,$hits) = DB_fetchARRAY($result);
                $stat_templates->set_var('item_url', $_CONF[site_url]. "/filemgmt/singlefile.php?lid=".$lid);
                $stat_templates->set_var('item_text', $title);
                $stat_templates->set_var('item_stat', $hits);
                $stat_templates->parse('stat_row','statrow',true); 
            }
            $stat_templates->parse('output','itemstats');
            $retval .= $stat_templates->finish($stat_templates->get_var('output'));
        } else {
            $retval .= $LANG_FILEMGMT['StatsMsg2'];
        }	
        $retval .= COM_endBlock();
    }
    return $retval;
}

/**
* Geeklog is asking us to provide any new items that show up in the type drop-down
* on search.php.  Let's let users search the Filelistings in the Filemgmt Plugin
*
*/

function plugin_searchtypes_filemgmt() 
{
    global $LANG_FILEMGMT;

	//COM_errorLOG("Filemgmt Plugin - Searchtypes called");
	$tmp['filemgmt'] = $LANG_FILEMGMT['searchlabel'];

    return $tmp;
}

/**
* this searches for files matching the user query and returns an array of 
* for the header and table rows back to search.php where it will be formated and
* printed 
*
* @query            string          Keywords user is looking for
* @datestart        date/time       Start date to get results for
* @dateend          date/time       End date to get results for
* @topic            string          The topic they were searching in
* @type             string          Type of items they are searching
* @author           string          Get all results by this author
*
*/
function plugin_dopluginsearch_filemgmt($query, $datestart, $dateend, $topic, $type, $author) 
{
	global $LANG_FILEMGMT, $_TABLES, $_FM_TABLES, $_CONF, $filemgmt_FileStoreURL;
	
		
	if (empty($type)) {
        $type = 'all';
    }
    
	// Bail if we aren't supppose to do our search
    if ($type <> 'all' AND $type <> 'filemgmt') {
        $plugin_results = new Plugin();
        $plugin_results->plugin_name = $LANG_FILEMGMT['plugin_name'];
        $plugin_results->searchlabel = $LANG_FILEMGMT['searchlabel'];
        return $plugin_results;
    }
	
	// Build search SQL
	$sql = "SELECT d.lid,t.lid, cid,title, url, submitter, comments, hits, UNIX_TIMESTAMP(date) as day, description 
	     FROM {$_FM_TABLES['filemgmt_filedetail']} d, {$_FM_TABLES['filemgmt_filedesc']} t WHERE d.lid=t.lid AND "; 
    $sql .= "((comments like '%$query%' OR comments like '$query%' OR comments like '%$query') ";
    $sql .= "OR (title like '%$query%' OR title like '$query%' OR title like '%$query') ";
	$sql .= "OR (description like '%$query%' OR description like '$query%' OR description like '%$query')) ";

	if (!empty($datestart) && !empty($dateend)) {
        $delim = substr($datestart, 4, 1);
        $DS = explode($delim,$datestart);
        $DE = explode($delim,$dateend);
        $startdate = mktime(0,0,0,$DS[1],$DS[2],$DS[0]);
        $enddate = mktime(0,0,0,$DE[1],$DE[2],$DE[0]) + 3600;
        $sql .= "AND (UNIX_TIMESTAMP(date) BETWEEN '$startdate' AND '$enddate') ";
    }

    if (!empty($author)) {
        $sql .= "AND (submitter = '$author') ";
    }
    $sql    .= "ORDER BY date desc";
	//COM_errorLOG("Filemgmt Search: ".$sql);
	
	// Perform search
    $result = DB_query($sql);
    
    // OK, now return coma delmited string of table header labels
	// Need to use language variables
    require_once($_CONF['path_system'] . 'classes/plugin.class.php');
    $plugin_results = new Plugin();
    $plugin_results->plugin_name = 'filemgmt';
    $plugin_results->searchlabel = $LANG_FILEMGMT['searchlabel_results'];
    $plugin_results->addSearchHeading('Title');
    $plugin_results->addSearchHeading('Description');
    $plugin_results->addSearchHeading('Author');
    $plugin_results->addSearchHeading('Downloads');
    $plugin_results->num_searchresults = DB_numRows($result);
	

    // NOTE if any of your data items need to be links then add them here! 
    // make sure data elements are in an array and in the same order as your
    // headings above!
	
	for ($i = 1; $i <= $plugin_results->num_searchresults; $i++) {
        $A = DB_fetchArray($result);
        $thetime = COM_getUserDateTimeFormat($A['day']);
		$url = $_CONF[site_url]. "/filemgmt/singlefile.php?lid=".$A['lid'];
		//COM_errorLOG("FileStoreURL:  ". $filemgmt_FileStoreURL);
		//COM_errorLOG("Filemgmt Search, found:  ". $url);
        $row = array("<a href={$url}>{$A['title']}</a>", wordwrap($A['description'],70,"<br>"),
            DB_getItem($_TABLES['users'],'username',"uid = '{$A["submitter"]}'"),$A['hits']);
        $plugin_results->addSearchResult($row);
	}
	
    $plugin_results->num_itemssearched = DB_count($_FM_TABLES['filemgmt_filedetail']);

    return $plugin_results;
}




/**
* This will put an option for Filemgmt Admin in the command and control block on
* moderation.php
*
*/
function plugin_cclabel_filemgmt() 
{
    global $LANG_FILEMGMT, $_CONF;

    return array($LANG_FILEMGMT['plugin_name'],$_CONF['site_admin_url'] . '/plugins/filemgmt/index.php',$_CONF['site_url'] . '/filemgmt/images/filemgmt.gif');
	
}

/**
* Setup the user menu options for this plugin
*
*/

function plugin_getuseroption_filemgmt() {
	global $_CONF, $_FM_TABLES, $LANG_FILEMGMT;
	if (SEC_hasRights('filemgmt.upload')) {
	   	return array($LANG_FILEMGMT['usermenu3'], $_CONF['site_url'] . '/filemgmt/submit.php');
	} else { 
	    //COM_errorLOG("Plugin: No user menu option access");
	    return false;
	}	
}


/**
* returns the administrative option for this plugin
* *
*/

function plugin_getadminoption_filemgmt() 
{
    global $_CONF, $_FM_TABLES, $LANG_FILEMGMT;
    if (SEC_hasRights('filemgmt.edit')) {
	    $result = DB_query("SELECT COUNT(*) FROM {$_FM_TABLES['filemgmt_filedetail']} WHERE status=0");
        list($submittedfiles) = DB_fetchARRAY($result);
        return array($LANG_FILEMGMT['admin_menu'], $_CONF['site_admin_url'] . '/plugins/filemgmt/index.php', $submittedfiles);

    }	
}

/**  
* Removes the datastructures for this plugin from the Geeklog database
*   
* This may get called by the install routine to undue anything done to this
* point.  To do that, $steps will have a list of steps to undo
*
* @steps   Array    Holds all the steps that have been completed by the install 
*
*/ 
function plugin_uninstall_filemgmt($steps = '') {   
    global $LANG_FILEMGMT, $_TABLES,$_FM_TABLES;
	global $filemgmt_deletetables, $filemgmt_deletegroups, $filemgmt_deleterights, $filemgmt_unassigngroups, $filemgmt_unassignrights, $filemgmt_deletecomments, $filemgmt_unregisterPI;

    COM_errorLog('Filemgmt Plugin - Deinstall initiated',1);
    	
    if (empty($steps) OR $steps['createtable'] == 1) {
        // Remove the Filemgmt tables - if they exist and install.cfg has not be set to skip this step
        COM_errorLog('Dropping Filemgmt tables',1);
	    if ($filemgmt_deletetables) {
			$res = @mysql_query("SELECT 1 FROM {$_FM_TABLES['filemgmt_cat']} LIMIT 1");
			if ($res)
			    DB_query("DROP TABLE {$_FM_TABLES['filemgmt_cat']}");
	
			$res = @mysql_query("SELECT 1 FROM {$_FM_TABLES['filemgmt_filedetail']} LIMIT 1");
			if ($res)
			    DB_query("DROP TABLE {$_FM_TABLES['filemgmt_filedetail']}");
	
	        $res = @mysql_query("SELECT 1 FROM {$_FM_TABLES['filemgmt_filedesc']} LIMIT 1");
			if ($res)
			    DB_query("DROP TABLE {$_FM_TABLES['filemgmt_filedesc']}");		
				
	        $res = @mysql_query("SELECT 1 FROM {$_FM_TABLES['filemgmt_votedata']} LIMIT 1");
			if ($res) 
			    DB_query("DROP TABLE {$_FM_TABLES['filemgmt_votedata']}");		
	        
			$res = @mysql_query("SELECT 1 FROM {$_FM_TABLES['filemgmt_brokenlinks']} LIMIT 1");
			if ($res)
			    DB_query("DROP TABLE {$_FM_TABLES['filemgmt_brokenlinks']}");		
			
			$res = @mysql_query("SELECT 1 FROM {$_FM_TABLES['filemgmt_history']} LIMIT 1");
			if ($res)
			    DB_query("DROP TABLE {$_FM_TABLES['filemgmt_history']}");		
		    
			COM_errorLog('...success',1);
		} else {
	        COM_errorLog($LANG_FILEMGMT['install_skip'], 1);
	    }
    }

	if (empty($steps) OR $steps['assigngroups'] == 1) {
        // Remove any group records where the Filemgmt security groups were assigned to - As in the Root group
        COM_errorLog('Removing group assignment records',1);
	    if ($filemgmt_unassigngroups) {
			$group1_id = DB_getItem($_TABLES['vars'], 'value', "name = 'fm_admingrp_id'");
			if ($group1_id > 0 ) {
				COM_errorLOG("group1_id: ". $group1_id);
		        DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $group1_id");
		    }
			$group2_id = DB_getItem($_TABLES['vars'], 'value', "name = 'fm_usersgrp_id'");
			if ($group2_id > 0) {
				COM_errorLOG("group2_id: ". $group2_id);
		        DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $group2_id");
		    }
		    COM_errorLog('...success',1);
        } else {
	        COM_errorLog($LANG_FILEMGMT['install_skip'], 1);
	    }
    }	
		
    if (empty($steps) OR $steps['creategroups'] == 1) {
        // Remove the Filemgmt seurity groups
        COM_errorLog('Removing Filemgmt-Admin and Filemgmt-Users groups',1);
	    if ($filemgmt_deletegroups) {
			$group1_id = DB_getItem($_TABLES['vars'], 'value', "name = 'fm_admingrp_id'");
			if ($group1_id) {
		        DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $group1_id");
		        DB_query("DELETE FROM {$_TABLES['vars']}   WHERE name = 'fm_admingrp_id'");
		    }
			$group1_id = DB_getItem($_TABLES['vars'], 'value', "name = 'fm_usersgrp_id'");
			if ($group2_id) {
		        DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $group2_id");
		        DB_query("DELETE FROM {$_TABLES['vars']}   WHERE name = 'fm_usersgrp_id'");
		    }
		    COM_errorLog('...success',1);
        } else {
	        COM_errorLog($LANG_FILEMGMT['install_skip'], 1);
	    }
    }		
    
	// Remove assigned features before removing access rights - need to get feature ID and remove for any and all groups
	if (empty($steps) OR $steps['assignrights'] == 1) {
        // Remove the Filemgmt security featurs assigned to groups
        COM_errorLog('Removing assigned Filemgmt Security rights - from the access table',1);
	    if ($filemgmt_unassignrights) {
	        $feature1_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'filemgmt.edit'");
	        $feature2_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'filemgmt.user'");
	        $feature3_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = 'filemgmt.upload'");
			// Remove all access rights from any group (in case they were assigned later by user)
            if ($feature1_id) 
			    DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feature1_id");
			if ($feature2_id) 
                DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feature2_id");
            if ($feature3_id) 
                DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feature3_id");
		    COM_errorLog('...success',1);
        } else {
	        COM_errorLog($LANG_FILEMGMT['install_skip'], 1);
	    }
    }		
   
  	if (empty($steps) OR $steps['createrights'] == 1) {
        // Remove the Filemgmt security groups
        COM_errorLog('Removing the Filemgmt Security rights - from the features table',1);
	    if ($filemgmt_deleterights) {
            DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_name = 'filemgmt.edit'");
            DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_name = 'filemgmt.user'");
            DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_name = 'filemgmt.upload'");
		    COM_errorLog('...success',1);
        } else {
	        COM_errorLog($LANG_FILEMGMT['install_skip'], 1);
	    }
    }		
		
    // Unregister the plugin with Geeklog and delete all associated comments if option true
    if (empty($steps) OR $steps['registeredPI'] == 1) {
        COM_errorLog('Attempting to unregister the plugin from Geeklog',1);
	    if ($filemgmt_unregisterPI) {
	        DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'filemgmt'");
	        DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = 'filemgmt'");
	        COM_errorLog('...success',1);
			if ($filemgmt_deletecomments) {
		        COM_errorLog('Attempting to delete all filemgmt type comments',1);
	            DB_query("DELETE FROM {$_TABLES['comments']} WHERE type = 'filemgmt'");
		        COM_errorLog('...success',1);
			}
		} else {
	        COM_errorLog($LANG_FILEMGMT['install_skip'], 1);
	    }
	}
	COM_errorLog('Succesfully completed FileMgmt Plugin De-Install Plugin',1);
    return true;
}


?>